/* TFTBitmap_all
 *  
 * The program expects that there are only displayable   
 * BMP files on the SD card and it will display all of   
 * them, each after the other. It works like a mini  
 * digital picture frame...
 */
#include <SPI.h>
#include <SD.h>
#include <TFT.h>  // Arduino LCD library

// pin definition for the Uno
#define sd_cs  4
#define lcd_cs 10
#define dc     9
#define rst    8

TFT TFTscreen = TFT(lcd_cs, dc, rst);
PImage logo;
File root;

void setup() {
  TFTscreen.begin();
  TFTscreen.background(0, 0, 0);
  if (!SD.begin(sd_cs)) {
    return;
  }
  root = SD.open("/");
}

void loop() {
  File entry =  root.openNextFile();
  if (entry) {
    logo = TFTscreen.loadImage(entry.name());
    if (logo.isValid() == false) {
      return;
    }
    TFTscreen.image(logo, 0, 0);
    entry.close();
    delay(5000);
  }
  else {
    root.rewindDirectory();
  }
}
