/* led_tristate
 *  
 * Egy LED vezérlése nyomógomb segítségével:
 *  - első lenyomásra a piros LED világítson
 *  - második lenyomásra a LED villog
 *  - harmadik lenyomásra a LED kialszik
 */

#define RED_LED 5                // D5-re van kötve a LED
#define G1      3                // D3-ra van kötve a nyomógomb

//Hardverfüggetlen rész (MSP430 Launchpad kártyán is futtatható!)
boolean waitforpress = true;     // Kezdetben lenyomásra várunk 
int led_state = LOW;             // Kezdetben a LED ki van kapcsolva
int timecount = 25;              // Villogás félperiódusának ideje

void setup() {
  pinMode(RED_LED,OUTPUT);       // legyen kimenet
  pinMode(G1,INPUT_PULLUP);      // bemenet belső felhúzással
}

void loop() {
  if(waitforpress) {             // Ha lenyomásra várunk és
    if(!digitalRead(G1)) {       // Ha lenyomás történt...
      if(++led_state > 2) led_state = 0;  // Állapot léptetése (2 után körülfordulás...)
      digitalWrite(RED_LED,led_state>0);  // LED állapot beállítása
      waitforpress = false;      // Következő stáció: felengedésre várunk
    }
  }  
  else {                         // Ha felengedésre vártunk és
    if(digitalRead(G1)) {        // Ha felengedést észlelünk...
      waitforpress = true;       // Következő stáció: lenyomásra várunk
    }
  }  
  delay(20);                     // Pergésmentesítő késleltetés
  if(led_state == 2)             // Ha villogtatás állapotban vagyunk
    if(--timecount == 0) {       // Ha az eltelt idő 25*20 ms, akkor
      digitalWrite(RED_LED,!digitalRead(RED_LED)); //LED állapot átbillentése
      timecount = 25;            // Következő billentés újabb 25*20 ms múlva...
    }
} 
