/* led_tristate2
 * 
 * Egy LED vezérlése nyomógomb segítségével:    
 * - első lenyomásra a LED világítson    
 * - második lenyomásra a LED villog    
 * - harmadik lenyomásra a LED kialszik
 */

#define RED_LED 5                // D5-re van kötve a LED
#define G1      3                // D3-ra van kötve a nyomógomb
boolean waitforpress = true;     //Kezdetben lenyomásra várunk
int led_state = LOW;             //Kezdetben a LED ki van kapcsolva
int timecount = 25;              //Villogás félperiódusának ideje

void setup() {
  pinMode(RED_LED, OUTPUT);      //legyen kimenet
  pinMode(G1, INPUT_PULLUP);     //Bemenet belső felhúzással
}

void loop() {
  if (waitforpress) {            //Ha lenyomásra várunk és
    if (!digitalRead(G1)) {      //Ha lenyomás történt...
      led_state = (led_state + 1) % 3;  //Állapot léptetése (2 után körülfordulás...)
      waitforpress = false;      //Következő stáció: felengedésre várunk
    }
  }
  else {                         //Ha felengedésre vártunk és
    if (digitalRead(G1)) {       //Ha felengedést észlelünk...
      waitforpress = true;       //Következő stáció: lenyomásra várunk
    }
  }
  switch (led_state) {
    case 0:
      digitalWrite(RED_LED, LOW); //Lekapcsoljuk a LED-et
      break;
    case 1:
      digitalWrite(RED_LED, HIGH); //Felkapcsoljuk a LED-et
      break;
    default:                     //Villogtatjuk a LED-et
      if (--timecount == 0) {    //Ha az eltelt idő 25*20 ms, akkor
        digitalWrite(RED_LED, !digitalRead(RED_LED)); //LED állapot átbillentése
        timecount = 25;          //Következő billentés újabb 25*20 ms múlva...
      }
  }
  delay(20);                     //Időalap és pergésmentesítő késleltetés
}
